'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.rename = undefined;

let dirCommand = (() => {
  var _ref = _asyncToGenerator(function* (program, filenames, opts) {
    let write = (() => {
      var _ref2 = _asyncToGenerator(function* (src, relative) {
        if (!(0, _util.isCompilableExtension)(relative)) return false;

        relative = rename(relative);

        const dest = _path2.default.join(program.outDir, relative);

        const code = yield (0, _util.convertFile)(src, opts, { filePath: dest });

        (0, _outputFileSync2.default)(dest, code);
        console.log(`${src} -> ${dest}`);

        return true;
      });

      return function write(_x4, _x5) {
        return _ref2.apply(this, arguments);
      };
    })();

    let handle = (() => {
      var _ref3 = _asyncToGenerator(function* (filename) {
        if (!(yield _fs2.default.exists(filename))) return;

        const stat = yield _fs2.default.stat(filename);

        if (stat.isDirectory(filename)) {
          const dirname = filename;
          const files = yield (0, _util.readdir)(dirname);
          yield Promise.all(files.map((() => {
            var _ref4 = _asyncToGenerator(function* (_filename) {
              const relative = _path2.default.relative(dirname, _filename);
              return write(_filename, relative);
            });

            return function (_x7) {
              return _ref4.apply(this, arguments);
            };
          })()));
        } else {
          yield write(filename, filename);
        }
      });

      return function handle(_x6) {
        return _ref3.apply(this, arguments);
      };
    })();

    yield Promise.all(filenames.map(handle));
  });

  return function dirCommand(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
})();

var _fs = require('mz/fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _outputFileSync = require('output-file-sync');

var _outputFileSync2 = _interopRequireDefault(_outputFileSync);

var _util = require('./util');

var _rename = require('../transforms/rename');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /* eslint-disable no-underscore-dangle, no-console */


const rename = exports.rename = relative => {
  const relativePath = _path2.default.parse(relative);
  relativePath.ext = '.js';
  relativePath.name = (0, _rename.pascalCase)(relativePath.name);
  relativePath.base = null;

  return _path2.default.format(relativePath);
};

exports.default = dirCommand;