'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

let fileCommand = (() => {
  var _ref = _asyncToGenerator(function* (program, filenames, opts) {
    let output = (() => {
      var _ref2 = _asyncToGenerator(function* () {
        const results = yield Promise.all(conversions);
        process.stdout.write(`${results.join('\n\n')}\n`);
      });

      return function output() {
        return _ref2.apply(this, arguments);
      };
    })();

    let walk = (() => {
      var _ref3 = _asyncToGenerator(function* () {
        const _filenames = [];
        conversions = [];

        yield Promise.all(filenames.map((() => {
          var _ref4 = _asyncToGenerator(function* (filename) {
            const stat = yield _fs2.default.stat(filename);
            if (stat.isDirectory()) {
              const dirname = filename;(yield (0, _util.readdirFilter)(dirname)).forEach(function (_filename) {
                _filenames.push(_filename);
              });
            } else {
              _filenames.push(filename);
            }
          });

          return function (_x4) {
            return _ref4.apply(this, arguments);
          };
        })()));

        _filenames.forEach(function (_filename) {
          conversions.push((0, _util.convertFile)(_filename, opts));
        });

        output();
      });

      return function walk() {
        return _ref3.apply(this, arguments);
      };
    })();

    let conversions;

    function stdin() {
      conversions = [];
      let code = '';

      process.stdin.setEncoding('utf8');

      process.stdin.on('readable', () => {
        const chunk = process.stdin.read();
        if (chunk !== null) code += chunk;
      });

      process.stdin.on('end', () => {
        conversions.push((0, _util.rawConvert)(code, opts, { filePath: 'svg-component' }));
        output();
      });
    }

    if (filenames.length === 0) stdin();else yield walk();
  });

  return function fileCommand(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
})();

var _fs = require('mz/fs');

var _fs2 = _interopRequireDefault(_fs);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /* eslint-disable no-underscore-dangle */


exports.default = fileCommand;