'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

let run = (() => {
  var _ref = _asyncToGenerator(function* () {
    const errors = [];
    let filenames = _commander2.default.args.reduce(function (globbed, input) {
      let files = _glob2.default.sync(input);
      if (!files.length) files = [input];
      return globbed.concat(files);
    }, []);

    filenames = (0, _uniq2.default)(filenames);

    yield Promise.all(filenames.map((() => {
      var _ref2 = _asyncToGenerator(function* (filename) {
        if (yield !_fs2.default.exists(filename)) {
          errors.push(`${filename} does not exist`);
        }
      });

      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    })()));

    if (errors.length) {
      console.error(errors.join('. '));
      process.exit(2);
    }

    const config = _extends({}, _commander2.default);

    if (config.template) {
      try {
        const template = require(_path2.default.join(process.cwd(), _commander2.default.template)); // eslint-disable-line global-require, import/no-dynamic-require
        if (template.default) config.template = template.default;else config.template = template;

        if (typeof config.template !== 'function') throw new Error('Template must be a function');
      } catch (error) {
        console.error(`Error when loading template: ${_commander2.default.template}\n`);
        console.error(error.stack);
        process.exit(2);
      }
    }

    const opts = (0, _configToOptions2.default)(config);

    const command = _commander2.default.outDir ? _dirCommand2.default : _fileCommand2.default;
    yield command(_commander2.default, filenames, opts);
  });

  return function run() {
    return _ref.apply(this, arguments);
  };
})();

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('mz/fs');

var _fs2 = _interopRequireDefault(_fs);

var _glob = require('glob');

var _glob2 = _interopRequireDefault(_glob);

var _uniq = require('lodash/uniq');

var _uniq2 = _interopRequireDefault(_uniq);

var _package = require('../../package.json');

var _package2 = _interopRequireDefault(_package);

var _fileCommand = require('./fileCommand');

var _fileCommand2 = _interopRequireDefault(_fileCommand);

var _dirCommand = require('./dirCommand');

var _dirCommand2 = _interopRequireDefault(_dirCommand);

var _configToOptions = require('../configToOptions');

var _configToOptions2 = _interopRequireDefault(_configToOptions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /* eslint-disable no-console */


_commander2.default.replaceAttrValues = [];

const values = val => {
  _commander2.default.replaceAttrValues = [..._commander2.default.replaceAttrValues, val.split('=')];
};

_commander2.default.version(_package2.default.version).usage('[options] <file>').option('-d, --out-dir <dirname>', 'output files into a directory').option('--no-svgo', 'disable SVGO').option('--no-prettier', 'disable Prettier').option('--template <file>', 'specify a custom template to use').option('--no-expand-props', 'disable props expanding').option('--ids', 'keep ids within the svg').option('--ref', 'add svgRef prop to svg').option('--icon', 'use "1em" as width and height').option('--no-view-box', 'remove viewBox').option('--native', 'add react-native support with react-native-svg').option('--replace-attr-value [old=new]', 'replace an attribute value', values).option('-p, --precision <value>', 'set the number of digits in the fractional part (svgo)').option('--no-title', 'remove title tag (svgo)').option('--tab-width', 'specify the number of spaces by indentation-level (prettier)').option('--use-tabs', 'indent lines with tabs instead of spaces (prettier)').option('--no-semi', 'remove semi-colons (prettier)').option('--single-quote', 'use single-quotes instead of double-quotes (prettier)').option('--trailing-comma <none|es5|all>', 'print trailing commas wherever possible when multi-line (prettier)').option('--no-bracket-spacing', 'print spaces between brackets in object literals (prettier)').option('--jsx-bracket-same-line', 'put the > of a multi-line JSX element at the end of the last line instead of being alone on the next line (prettier)');

_commander2.default.on('--help', () => {
  console.log(`
  Examples:
    svgr --replace-attr-value "#fff=currentColor" icon.svg
`);
});

_commander2.default.parse(process.argv);

run().catch(error => {
  setTimeout(() => {
    throw error;
  });
});