'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.readdirFilter = exports.readdir = exports.convertFile = exports.rawConvert = undefined;

let convertFile = exports.convertFile = (() => {
  var _ref = _asyncToGenerator(function* (filePath, opts) {
    const code = yield _fs2.default.readFile(filePath, 'utf-8');
    return (0, _.rawConvert)(code, opts, { filePath });
  });

  return function convertFile(_x, _x2) {
    return _ref.apply(this, arguments);
  };
})();

let readdirFilter = exports.readdirFilter = (() => {
  var _ref2 = _asyncToGenerator(function* (dirname) {
    return (yield (0, _recursiveReaddir2.default)(dirname)).filter(isCompilableExtension);
  });

  return function readdirFilter(_x3) {
    return _ref2.apply(this, arguments);
  };
})();

exports.exitError = exitError;
exports.isCompilableExtension = isCompilableExtension;

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _path = require('path');

var _fs = require('mz/fs');

var _fs2 = _interopRequireDefault(_fs);

var _recursiveReaddir = require('recursive-readdir');

var _recursiveReaddir2 = _interopRequireDefault(_recursiveReaddir);

var _ = require('../');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /* eslint-disable no-console */


exports.rawConvert = _.rawConvert;
function exitError(error) {
  console.error(_chalk2.default.red(error));
  process.exit(1);
}

exports.readdir = _recursiveReaddir2.default;


const COMPILABLE_EXTENSIONS = ['.svg', '.SVG'];

function isCompilableExtension(filename) {
  const ext = (0, _path.extname)(filename);
  return COMPILABLE_EXTENSIONS.includes(ext);
}