'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.rawConvert = exports.removeStyle = exports.removeComments = exports.wrapIntoComponent = exports.svgRef = exports.replaceAttrValue = exports.expandProps = exports.emSize = exports.stripAttribute = exports.jsx = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

let rawConvert = exports.rawConvert = (() => {
  var _ref = _asyncToGenerator(function* (code, options, state) {
    state = expandState(state);
    let result = code;
    result = options.svgo ? yield (0, _svgo2.default)(result, options.svgo, state) : result;
    result = yield (0, _h2x2.default)(result, options.h2x, state);
    result = yield (0, _transform2.default)(result, { transform: options.template }, state);
    result = options.prettier ? yield (0, _prettier2.default)(result, options.prettier, state) : result;
    return result;
  });

  return function rawConvert(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
})();

var _h2xPluginJsx = require('h2x-plugin-jsx');

var _h2xPluginJsx2 = _interopRequireDefault(_h2xPluginJsx);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _svgo = require('./plugins/svgo');

var _svgo2 = _interopRequireDefault(_svgo);

var _h2x = require('./plugins/h2x');

var _h2x2 = _interopRequireDefault(_h2x);

var _prettier = require('./plugins/prettier');

var _prettier2 = _interopRequireDefault(_prettier);

var _transform = require('./plugins/transform');

var _transform2 = _interopRequireDefault(_transform);

var _wrapIntoComponent = require('./transforms/wrapIntoComponent');

var _wrapIntoComponent2 = _interopRequireDefault(_wrapIntoComponent);

var _rename = require('./transforms/rename');

var _stripAttribute = require('./h2x/stripAttribute');

var _stripAttribute2 = _interopRequireDefault(_stripAttribute);

var _emSize = require('./h2x/emSize');

var _emSize2 = _interopRequireDefault(_emSize);

var _expandProps = require('./h2x/expandProps');

var _expandProps2 = _interopRequireDefault(_expandProps);

var _svgRef = require('./h2x/svgRef');

var _svgRef2 = _interopRequireDefault(_svgRef);

var _replaceAttrValue = require('./h2x/replaceAttrValue');

var _replaceAttrValue2 = _interopRequireDefault(_replaceAttrValue);

var _removeComments = require('./h2x/removeComments');

var _removeComments2 = _interopRequireDefault(_removeComments);

var _removeStyle = require('./h2x/removeStyle');

var _removeStyle2 = _interopRequireDefault(_removeStyle);

var _configToOptions = require('./configToOptions');

var _configToOptions2 = _interopRequireDefault(_configToOptions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.jsx = _h2xPluginJsx2.default;
exports.stripAttribute = _stripAttribute2.default;
exports.emSize = _emSize2.default;
exports.expandProps = _expandProps2.default;
exports.replaceAttrValue = _replaceAttrValue2.default;
exports.svgRef = _svgRef2.default;
exports.wrapIntoComponent = _wrapIntoComponent2.default;
exports.removeComments = _removeComments2.default;
exports.removeStyle = _removeStyle2.default;


function expandState(state) {
  const componentName = (0, _rename.pascalCase)(_path2.default.parse(state.filePath).name);
  return _extends({}, state, { componentName });
}

exports.default = (() => {
  var _ref3 = _asyncToGenerator(function* (code, _ref2 = {}, initialState = {}) {
    var _ref2$componentName = _ref2.componentName;

    let componentName = _ref2$componentName === undefined ? 'SvgComponent' : _ref2$componentName,
        config = _objectWithoutProperties(_ref2, ['componentName']);

    return rawConvert(code, (0, _configToOptions2.default)(config), _extends({}, initialState, {
      filePath: componentName
    }));
  });

  function convert(_x4) {
    return _ref3.apply(this, arguments);
  }

  return convert;
})();