'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
const componentsToList = components => [...components].filter(component => component !== 'Svg').join(', ');

const logUnsupportedComponents = components => {
  if (!components.size) return '';
  return `
// SVGR has dropped some elements not supported by react-native-svg: ${componentsToList(components)}
`;
};

exports.default = (opts = {}) => (code, state) => {
  var _state$reactNativeSvg = state.reactNativeSvgReplacedComponents;
  const reactNativeSvgReplacedComponents = _state$reactNativeSvg === undefined ? new Set() : _state$reactNativeSvg;
  var _state$unsupportedCom = state.unsupportedComponents;
  const unsupportedComponents = _state$unsupportedCom === undefined ? new Set() : _state$unsupportedCom;


  let props = '';

  if (opts.expandProps && opts.ref) {
    props = '{svgRef, ...props}';
  } else if (opts.expandProps) {
    props = 'props';
  } else if (opts.ref) {
    props = '{svgRef}';
  }

  return `import React from 'react'
  import Svg, { ${componentsToList(reactNativeSvgReplacedComponents)} } from 'react-native-svg';
  ${logUnsupportedComponents(unsupportedComponents)}


  const ${state.componentName} = (${props}) => ${code}

  export default ${state.componentName}`;
};