'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.svgrLoader = undefined;

var _loaderUtils = require('loader-utils');

var _ = require('./');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function svgrLoader(source) {
  const callback = this.async();
  const options = (0, _loaderUtils.getOptions)(this) || {};

  const readSvg = () => new Promise((resolve, reject) => {
    this.fs.readFile(this.resourcePath, (err, result) => {
      if (err) reject(err);
      resolve(result);
    });
  });

  const exportMatches = source.match(/^module.exports\s*=\s*(.*)/);
  const previousExport = exportMatches ? exportMatches[1] : null;

  readSvg().then(svg => (0, _2.default)(svg, options, { webpack: { previousExport } })).then(result => callback(null, result)).catch(err => callback(err));
}

function svgrLoaderWithWarning(source) {
  /* eslint-disable no-console */
  console.warn('Using "svgr/lib/webpack" is deprecated and will be removed in v2. Please use "svgr/webpack" instead.');
  /* eslint-enable no-console */
  return svgrLoader.call(this, source);
}

exports.svgrLoader = svgrLoader;
exports.default = svgrLoaderWithWarning;